# UESC
# Ciência da Computação
# Disciplina: Probabilidade e Estatística 2016.1
# Aluno: Álvaro Maciel
# Melhorado: 27/10/2022 08:26:106
# Professor: José Claudio Faria

#. Amostragem sistemática
# Numa gerência, produz-se em média 500 bobinas de aço por dia. 
# Chega-se à conclusão de que é necessário avaliar o controle de qualidade de 20 ou 4% dessas bobinas.
# Determine quais bobinas poderiam compor a amostra.

N_pop <- 500
n_amo <- 20

#.. Intervalo da amostragem
# O valor K é obtido da divisão entre a quantidade da população e a quantidade de amostras, em valor.
# Outra forma de calcular esse valor K, seria k ~= (1/percentagem) * 100
(K <- N_pop / n_amo)

# Determina o primeiro elemento da amostra, que será referência para os demais

#.. A função "sample", nesse caso, retira um valor pseudoaleatorio como amostra, esse valor está entre 1 e 25, com reposição.
set.seed(2021)
(a1 <- sample(K,
              1))

# Vetor de armazenamento dos elementos da amostra
# (como vai ser indexado é necessário declaração anterior)
amo <- numeric()
length(amo)

# Laço que insere na amostra cada uma das bobinas através de uma PA
#.. A amostra será armazenado no vetor 'amo', 20 valores tendo como primeiro valor a1, e somando K a cada novo valor até obter os 20 valores

#. Opções
#----------------------
#.. Via loop for
#----------------------
for (i in 1:(n_amo))
{
  amo[i] <- a1 + (i - 1) * K
}

amo
length(amo)

#----------------------
#.. Via loop repeat
#----------------------
amo <- numeric()
length(amo)

i <- 0
repeat
{
  i <- i + 1
  amo[i] <- a1 + (i - 1) * K

  if (length(amo) == 20) break
}

amo
length(amo)

#----------------------
#.. Via loop while
#----------------------
amo <- numeric()
length(amo)

i <- 1
while (length(amo) < 20)
{
  amo[i] <- a1 + (i - 1) * K
  i <- i + 1
}

amo
length(amo)
